// neuesFax.cpp : Legt das Klassenverhalten fr die Anwendung fest.
//
// Version 1,00 vom 15.1.2009
#include "stdafx.h"
#include "neuesFax.h"
#include "neuesFaxDlg.h"
#include "io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CNeuesFaxApp

BEGIN_MESSAGE_MAP(CNeuesFaxApp, CWinApp)
	//{{AFX_MSG_MAP(CNeuesFaxApp)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNeuesFaxApp Konstruktion

CNeuesFaxApp::CNeuesFaxApp()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
	// Alle wichtigen Initialisierungen in InitInstance platzieren
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CNeuesFaxApp-Objekt

CNeuesFaxApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CNeuesFaxApp Initialisierung

BOOL CNeuesFaxApp::InitInstance()
{
	// Standardinitialisierung
	// Wenn Sie diese Funktionen nicht nutzen und die Gre Ihrer fertigen 
	//  ausfhrbaren Datei reduzieren wollen, sollten Sie die nachfolgenden
	//  spezifischen Initialisierungsroutinen, die Sie nicht bentigen, entfernen.

#ifdef _AFXDLL
	Enable3dControls();			// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
#else
	Enable3dControlsStatic();	// Diese Funktion bei statischen MFC-Anbindungen aufrufen
#endif



	time_t	newest_time=0,cmp_time=0;
	CString fax_pfad="",fax_wCard="",xnf_pfad="";
	int wait=30;

	// MFC initialisieren, Ausgabe und Fehlermeldung bei Fehlern

	xnf_pfad=__argv[0];
	int idx=xnf_pfad.ReverseFind('.');
	if(idx>-1)
		xnf_pfad=xnf_pfad.Left(idx+1)+"xnf";
	else
		xnf_pfad="neuesFax.xnf";
	struct _finddata_t files;
	long hFile;
	if(__argc==2)
	{
		fax_pfad=__argv[1];
		int idx=fax_pfad.ReverseFind('\\');
		if(idx>-1)
		{
			fax_pfad=fax_pfad.Left(idx+1);
			fax_wCard=fax_pfad+"*";
		}
	}
	else
	{
		FILE *iFile=fopen(xnf_pfad,"rb");
		if(iFile)
		{
			char tmp[2000];
			while(!feof(iFile))
			{
				char *ptr;
				fgets(tmp,sizeof(tmp),iFile);
				ptr=strchr(tmp,'<');
				if(ptr)
				{
					switch(ptr[1])
					{
					case 'd':
					case 'D':
						if(!strnicmp(ptr,"<Dir>",5))
						{	int idx;
							fax_pfad=ptr+5;
							idx=fax_pfad.Find("<");
							if(idx>-1)
								fax_pfad=fax_pfad.Left(idx);
						}
						break;
					case 'l':
					case 'L':
						if(!strnicmp(ptr,"<LastTime>",10))
							cmp_time=atoi(ptr+10);
						break;
					case 'c':
					case 'C':
						if(!strnicmp(ptr,"<CheckTime>",11))
							wait=atoi(ptr+11);
						break;
					}
				}
			};
			fax_wCard=fax_pfad+"*";
			fclose(iFile);
		}
		else
			exit(1);
	}

	/* Find first file in current directory */
	do
	{
		enum {FRAGE,OEFFNEN,IGNORIEREN} akt=FRAGE;
		if( (hFile = _findfirst( fax_wCard, &files )) != -1L )
		{
			do
			{
				if(files.name[0]!='.')
				{
					if(files.time_write>cmp_time || files.time_create>cmp_time)
					{
						if(akt==FRAGE)
						{
						CNeuesFaxDlg dlg;
							m_pMainWnd = &dlg;
							int nResponse = dlg.DoModal();
							if (nResponse == IDOK)
								akt=OEFFNEN;
							else if (nResponse == IDCANCEL)
								akt=IGNORIEREN;
						}
						if(akt==OEFFNEN)
						{
							CString fax=fax_pfad+files.name;
							ShellExecute(NULL,"open",fax,"","NULL",SW_SHOW );
						}
					}
					if(files.time_write>newest_time)
						newest_time =files.time_write;
					if(files.time_create>newest_time)
						newest_time =files.time_create;
				}
			}
			while( _findnext( hFile, &files ) == 0 );
			if(newest_time>cmp_time)
			{
				FILE *iFile=fopen(xnf_pfad,"wb");
				if(iFile)
				{
					fprintf(iFile,"<?xml version=\"1.0\"?>\n");
					fprintf(iFile," <neuesFax>\n");
					fprintf(iFile," <!-- Time of last Fax, Path and how often the program should check for new faxes -->\n");
					fprintf(iFile,"  <Dir>%s</Dir>\n",fax_pfad);
					fprintf(iFile,"  <LastTime>%ld</LastTime>\n",newest_time);
					fprintf(iFile,"  <CheckTime>%d</CheckTime>\n",wait);
					fprintf(iFile," </neuesFax>\n");
					fclose(iFile);
				}
				cmp_time=newest_time;
			}
		   _findclose( hFile );
		}
		Sleep(wait*1000);
	}while(1);

	return 0;
}
